package interpreter

enum PairOp:
  case First
  case Second

enum NumOp:
  case Add
  case Sub
  case Mul
  case Div

enum Expr:
  case Num(n: Int)
  case NumExpr(op: NumOp, left: Expr, right: Expr)
  case Var(name: String)
  case Let(name: String, e: Expr, body: Expr)
  case Pair(first: Expr, second: Expr)
  case PairExpr(op: PairOp, e: Expr)
  case IsPair(e: Expr)
  case If(cond: Expr, thene: Expr, elsee: Expr)
