package interpreter

import scala.language.adhocExtensions

trait WithCounter extends Interpreter:
  var counter = 0
  abstract override def evaluate(e: Expr)(using env: Env): EvalResult =
    counter += 1
    super.evaluate(e)
  abstract override def topLevelEvaluate(e: Expr): StrictResult =
    counter = 0
    super.topLevelEvaluate(e)

class StrictInterpreterWithCounter extends StrictInterpreter with WithCounter

class LazyInterpreterWithCounter extends LazyInterpreter with WithCounter
